#!perl
# $Id: gpx2csv.pl,v 1.4 2018/01/04 16:00:55 feyrer Exp feyrer $

# XXX TODO: Dieses ganze Projekt auf Github packen!
# XXX TODO: Favoritenpunkte anzeigen - nicht in GPX, braucht API-Zugriff; vielleicht via GPX-Export? :(
#
# Copyright (c) 2018 by Hubert Feyrer <hubert@feyrer.de>
#

$inwpt = 0;
while(<>) {
    if (/<wpt lat="([^"]*)" lon="([^"]*)">/) {
	# <wpt lat="51.322517" lon="12.3767">
	($lat, $lon) = ($1, $2);
	$inwpt=1;
    }
    if ($inwpt and m|<name>([^<]*)</name>|) {
	# <name>GC6C3HJ</name>
	$gccode = $1;
    }
    if ($inwpt and m|<desc>([^<]*)</desc>|) {
	# <desc>e+ by terrasax, Multi-cache (2/1)</desc>
	$descetc = $1;
	#print "descetc=$descetc\n";
	
	($desc, $owner, $type, $diff, $terr) = $descetc =~
	    m|^(.*) by (.*), (.*cache\|Letterbox Hybrid\|Cache In Trash Out Event) \(([0-9.]*)[,/]([0-9.]*)\)|i;

	$type =~ s,(Traditional|Webcam|Virtual) Cache,$1,i;
	$type =~ s,(Letterbox) Hybrid,$1,i;
	$type =~ s,Cache In Trash Out Event,CITO-Event,i;
	$type =~ s,Multi-cache,Multi,i;
	$type =~ s,Traditional,Tradi,;

	$desc =~ s,&amp;,\&,g;
	$desc =~ s,&lt;,<,g;
	$desc =~ s,&gt;,>,g;
	$desc =~ s,",',g;
	$desc =~ s,\s*$,,g;

	print "desc=$desc\n" if $desc =~ m|"|;
    }
    if (m|</wpt>|) {
	# </wpt>	
	print "$lon,$lat,\"$gccode $desc ($type D${diff} T${terr})\"\n";
	$inwpt=0;
    }
}
